BEGIN { boundary = "^%%%$"
        dnr = 1
        HEX = "123456789ABCDEF"
        B64 = "BCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
      }

function b64(s)
{ r = ""
  while( length(s) >= 4 )
  { c1 = index(B64,substr(s,1,1))
    c2 = index(B64,substr(s,2,1))
    c3 = index(B64,l3=substr(s,3,1))
    c4 = index(B64,l4=substr(s,4,1))
    s = substr(s,5)
    if( l4 != "=" )
      r = r sprintf("%c%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2),and(255,lshift(c3,6))+c4)
    else if( l3 != "=" )
      r = r sprintf("%c%c",and(255,lshift(c1,2))+rshift(c2,4),and(255,lshift(c2,4))+rshift(c3,2))
    else
      r = r sprintf("%c",and(255,lshift(c1,2))+rshift(c2,4))
  }
  return r
}

function qp(s)
{ r = ""
  while( i = index(s, "=") )
  { r = r substr(s, 1, i-1) sprintf("%c", index(HEX,substr(s,i+1,1))*16+index(HEX,substr(s,i+2,1)))
    s = substr(s, i+3)
  }
  return r s
}

function decqp(z)
{ if(z)
  { o = ""
    while( i = index(z, "=?") )
    { o = o substr(z, 1, i-1)
      z = substr(z, i+2)
      i = index(z, "?")
      c = substr(z, 1, i-1)
      e = substr(z, i+1, 1)
      d = substr(z, i+3)
      j = index(d, "?=")
      z = substr(d, j+2)
      d = substr(d, 1, j-1)
      if( d != "" )
      { gsub("_", " ", d)
        if( c == "us-ascii" )
        { if( e == "Q" || e == "q" )
            o = o qp(d)
          else if( e == "B" || e == "b" )
            o = o b64(d)
          else
            o = o d
        }
        if( c == "iso-8859-1" )
        { if( e == "Q" || e == "q" )
          { cmd = "iconv -f iso-8859-1 -t UTF-8"
            print qp(d) |& cmd
            close(cmd, "to")
            cmd |& getline u
            o = o u
            close(cmd, "from")
          }
          else if( e == "B" || e == "b" )
          { cmd = "iconv -f iso-8859-1 -t UTF-8"
            print b64(d) |& cmd
            close(cmd, "to")
            cmd |& getline u
            o = o u
            close(cmd, "from")
          }
          else
            o = o d
        }
        else if( c == "utf-8" )
        { if( e == "Q" || e == "q" )
            o = o qp(d)
          else if( e == "B" || e == "b" )
            o = o b64(d)
          else
            o = o d
        }
      }
    }
    return o z
  }
  else
    return ""
}


/boundary=/ { gsub("^.*boundary=", "", $0)
              if( $0 ~ "^\".*\"$" )
	        gsub("\"", "", $0)
              boundary = "--" $0
            }

$0 == boundary {
  chs = ""
  while( getline > 0 )
  { while( $0 != "" )
    { if( $1 == "Content-Type" )
      { ct = $2
        if( $0 ~ /charset=utf-8/ )
          chs = "-c utf8"
      }
      else if( $1 == "Content-Transfer-Encoding" )
        cte = $2
      else if( $1 == "Content-Disposition" )
        cd = $2
      if( $0 ~ " *filename=" )
      { gsub(".*filename=", "", $0)
        if( $0 ~ "^\".*\"$" )
          gsub("\"", "", $0)
        gsub(".*/", "", $0)
        filename = decqp($0)
      }
      getline
    }
    awkb64 = 0
    awkqp = 0
    if( cte == "base64" )
      awkb64 = 1
    else if( cte == "quoted-printable" )
      awkqp = 1
    if( filename == "" )
    { if( ct ~ "^text" )
      { if( TXTUNIT == "" )
          pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Body "DT" body.txt"
        else
          pcmd = "send_file2uls "chs" "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Body "DT" \""TXTUNIT"\""
      }
      else
      { gsub("/.*", "", ct)
        pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Attachment "DT" body."ct
      }
    }
    else
      pcmd = "send_stdin_file "UH" \""ULSSECTION"\" \""ULSTESTSTEP"\" Attachment "DT" \"" filename "\""
    if( awkb64 )
    { while( getline > 0 )
      { if( $0 == "" )
        { getline
          if( $0 ==  boundary || $0 == boundary "--" )
            break
        }
        printf("%s", b64($0)) | pcmd
      }
    }
    else if( awkqp )
    { ll = 0
      while( getline > 0 )
      { if( ll )
        { if( $0 ==  boundary || $0 == boundary "--" )
            break
          else
            print "" | pcmd
        }
        if( ll = ($0 == "") )
          continue
        o = ""
        l = $0
        while( i = index(l, "=") )
        { if( i == length(l) )
          { o = o substr(l, 1, i-1)
            nlf = 0
            l = ""
          }
          else
          { o = o substr(l, 1, i-1) sprintf("%c", index(HEX,substr(l,i+1,1))*16+index(HEX,substr(l,i+2,1)))
            l = substr(l, i+3)
          }
        }
        printf("%s%s%s", o, l, nlf ? "\n": "") | pcmd
      }
    }
    else
    { ll = 0
      while( getline > 0 )
      { if( ll )
        { if( $0 ==  boundary || $0 == boundary "--" )
            break
          else
            print "" | pcmd
        }
        if( ll = ($0 == "") )
          continue
        print $0 | pcmd
      }
    }
    close(pcmd)
    filename = ct = cte = cd = ""
    if( $0 == boundary "--" )
      exit
  }
}
